# Paranuara Challenge
Paranuara is a class-m planet. Those types of planets can support human life, for that reason the president of the Checktoporov decides to send some people to colonise this new planet and
reduce the number of people in their own country. After 10 years, the new president wants to know how the new colony is growing, and wants some information about his citizens. Hence he hired you to build a rest API to provide the desired information.

The government from Paranuara will provide you two json files (located at resource folder) which will provide information about all the citizens in Paranuara (name, age, friends list, fruits and vegetables they like to eat...) and all founded companies on that planet. 
Unfortunately, the systems are not that evolved yet, thus you need to clean and organise the data before use. 
For example, instead of providing a list of fruits and vegetables their citizens like, they are providing a list of favourite food, and you will need to split that list (please, check below the options for fruits and vegetables).

## New Features
Your API must provides these end points:
- Given a company, the API needs to return all their employees. Provide the appropriate solution if the company does not have any employees.
- Given 2 people, provide their information (Name, Age, Address, phone) and the list of their friends in common which have brown eyes and are still alive.
- Given 1 people, provide a list of fruits and vegetables they like. This endpoint must respect this interface for the output: `{"username": "Ahi", "age": "30", "fruits": ["banana", "apple"], "vegetables": ["beetroot", "lettuce"]}`

## Delivery
To deliver your system, you need to send the link on GitHub. Your solution must provide tasks to install dependencies, build the system and run. Solutions that does not fit this criteria **will not be accepted** as a solution. Assume that we have already installed in our environment Java, Ruby, Node.js, Python, MySQL, MongoDB and Redis; any other technologies required must be installed in the install dependencies task. Moreover well tested and designed systems are one of the main criteria of this assessement 

## Solution

I have decided to simply load the information into a relational database (sqlite). I guess this
could be done more nicely with MongoDB, but I do not have experience with it, so I went with a
more traditional approach.

Here is a diagram of it

![diagram](diagrams/db.png)

Given the simplicity of the code, I have put all in a single dir, although there are classes
with different responsabilities, essentially

* server.py: Initializes the flask app and runs the http endpoints. Notice that they accept any
http method, although I could have just supported HTTP GET.

* base_dao, company_dao, food_dao and people_dao: In charge of dealing with the database,
base_dao simply provides a connection and the rest of the classes extend this one. It is all
fairly straightforward.

* importer: A couple of functions here whose only job is to load the json files into the database,
once the db is loaded, they do not run again


## Assumptions.

At the moment of writing, I had to figure out how many different foods were available and how to
classify them into vegetables or fruits. Adding new types of foods could be problematic. Also the
system is not ready to handle food that are vegetables and fruits at the same time (tomatatoes?).

The other assumption is that you cannot be friend with yourself, which seems to make sense to me,
however the data contains entries of friends that are friends with themselves, I have decided to
simply ignore those (I treat them as an error in the data).

## How to run.

I favor simplicity over everything, so I have used docker for it.

If you already have docker installed, then simply run

```docker-compose up```

and then open a browser and point it to localhost:5000 if you need to use a different port, just
change the docker-compose.yml file.

If you need to install docker run setup.sh (it assumes you run a debian environment!).


## Show me something!

I am not big on frontend but I have decided to simply use an autogenerated page from the python
docs, this allows to quickly explore the api

![diagram](diagrams/api.png)

I think it is fairly self-explanatory.

## Some extra considerations.

Why docker? Simply because I think is simpler, it should not matter if an application runs php, java, python
or whateverlangyouprefer, running it should be easy and simple, docker allows that. I have been using it
for 3,5 years now and I simply love it.

Why sqlite? Same as above, sqlite is simply a... file so it makes it very easy to include it in the container
itself, it is true that the exercise mentions that a MySQL server is available but... what would be the address?
sure I could assume localhost:3306 but then I would have to create the database tables also and so on and so on,
with docker + sqlite, you can get everything running with one command ```docker-compose up``` as mentioned before,
in the event you do not have docker installed in your machine, simply execute ```setup.sh```

## How do we test/break it.

Say you want to reload the json files, in that case, simply modify the docker-compose.yml file and use

```- RELOAD_DATA=1```

Notice! reloading the data takes a bit (around a minute), I was fairly surprised but it turns out that the sqlite
driver for python tries to outsmart you and creates a transaction per call... Considering that we are not going to be
reloading the data all the time (I have just provided the option because I assume you might have other json files
you might want to try) i think we can afford that performance penalty.

But what if you have a different set of json files? in that case you have to

 * Overwrite the json files in the resources folder
 * Modify docker-compose.yml to use ```- RELOAD_DATA=1```
 * Rebuild the container by doing ```docker-compose build```
 * Run the container ```docker-compose up```

### A note about unit tests.

I am a big advocate for unit tests, but in this case I have not written them, the most obvious reasons is simply time,
I hope you enjoy exploring my code and my solution.

Moriano.